<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Subdomains extends CI_Controller {

	function __construct()
	{
		parent::__construct();
		//$this->load->library('ion_auth');
		$this->load->helper('url');
		$this->load->helper('form');
		$this->load->library('form_validation');
		
		$this->load->model('sitemodel');
		$this->load->model('subdomainmodel');
		//$this->load->model('usermodel');
		//$this->load->model('pagemodel');
		
		//$this->load->library('elements');
			
		$this->data['pageTitle'] = $this->lang->line('subdomains_page_title');
		
		if(!$this->ion_auth->logged_in()) {
			redirect('/login');
		}	
	}
	
	
	/*
	
		lists all sites
	
	*/

	public function index()
	{	
		
	}
	
	
	
	/*
	
		load page builder
	
	*/
	
	public function create() {
		$this->data['page'] = "subdomains";
		$this->data['settings'] = $this->subdomainmodel->getConfig();
		$this->data['subdomain'] = $this->session->userdata('subdomain');
		$this->session->set_flashdata('subdomain', $this->session->userdata('subdomain'));
		
		$this->load->view('subdomains/settings', $this->data);
	
	}
	
	/*
	
		Used to create new sites AND save existing ones
	
	*/
	
	public function update( $forPublish = 0 ) {
	
		if(!$this->ion_auth->logged_in()) {
			
			redirect('/login');
		
		}
		
		$this->form_validation->set_rules('subdomain', 'subdomain', 'required|xss_clean');
		
		if ($this->form_validation->run() == FALSE) {
					
			//some errors :(
			$this->session->set_flashdata('error', $this->lang->line('assets_update_error').validation_errors());
		
		} else {
					
			//all good :)
			
			//update the data
			$result = $this->subdomainmodel->updateConfig($_POST);
			if($result['ret'] == 1){
				$this->session->set_flashdata('success', $this->lang->line('assets_update_success'));
				$this->session->set_flashdata('subdomain', $this->session->userdata('subdomain'));
			}else{
				$this->session->set_flashdata('error', $this->lang->line('assets_update_error').$result['message']);
			}
			
		}
		
		redirect('subdomains/create', 'location');	
	
	}	
 
}

/* End of file sites.php */
/* Location: ./application/controllers/sites.php */